-- Glue - a GLUT interface for Euphoria 2.3+
--
--             by Mic, 2000/2003
--
--            version 030613
--

 
--
-- Constants, constants and even more constants.  ..and some function-links too..
-- Straight from glut.h. 
--
-- Note that some things aren't done as they should be. f.x. all #IFDEFs are ignored.
-- Maybe I'll fix this later on..
--


include misc.e
include gl.e
include glu.e
--include asm.e

 

global constant glue_cmdline = allocate_string("glue"),
		glue_argc = allocate(8),
		glue_argv = glue_argc+4
		poke4(glue_argc,1)
		poke4(glue_argv,glue_cmdline)

		
-- Dunno what these should be set to. Turn 'em up if you wish to.. 
global constant GLUT_API_VERSION = 3
global constant GLUT_XLIB_IMPLEMENTATION = 12




--/* Display mode bit masks. */
global constant GLUT_RGB 		= 0
global constant GLUT_RGBA 		= GLUT_RGB
global constant GLUT_INDEX 		= 1
global constant GLUT_SINGLE 		= 0
global constant GLUT_DOUBLE 		= 2
global constant GLUT_ACCUM 		= 4
global constant GLUT_ALPHA 		= 8
global constant GLUT_DEPTH 		= 16
global constant GLUT_STENCIL 		= 32
--#if (GLUT_API_VERSION >= 2)
global constant GLUT_MULTISAMPLE 	= 128
global constant GLUT_STEREO 		= 256
--#endif
--#if (GLUT_API_VERSION >= 3)
global constant GLUT_LUMINANCE 		= 512
--#endif

--/* Mouse buttons. */
global constant GLUT_LEFT_BUTTON 	= 0
global constant GLUT_MIDDLE_BUTTON 	= 1
global constant GLUT_RIGHT_BUTTON 	= 2

--/* Mouse button  state. */
global constant GLUT_DOWN 		= 0
global constant GLUT_UP 		= 1

--#if (GLUT_API_VERSION >= 2)
--/* function keys */
global constant GLUT_KEY_F1 		= 1
global constant GLUT_KEY_F2 		= 2
global constant GLUT_KEY_F3 		= 3
global constant GLUT_KEY_F4 		= 4
global constant GLUT_KEY_F5 		= 5
global constant GLUT_KEY_F6 		= 6
global constant GLUT_KEY_F7 		= 7
global constant GLUT_KEY_F8 		= 8
global constant GLUT_KEY_F9 		= 9
global constant GLUT_KEY_F10 		= 10
global constant GLUT_KEY_F11 		= 11
global constant GLUT_KEY_F12 		= 12
--/* directional keys */
global constant GLUT_KEY_LEFT 		= 100
global constant GLUT_KEY_UP 		= 101
global constant GLUT_KEY_RIGHT 		= 102
global constant GLUT_KEY_DOWN 		= 103
global constant GLUT_KEY_PAGE_UP 	= 104
global constant GLUT_KEY_PAGE_DOWN 	= 105
global constant GLUT_KEY_HOME 		= 106
global constant GLUT_KEY_END 		= 107
global constant GLUT_KEY_INSERT 	= 108
--#endif

--/* Entry/exit  state. */
global constant GLUT_LEFT 	= 0
global constant GLUT_ENTERED 	= 1

--/* Menu usage  state. */
global constant GLUT_MENU_NOT_IN_USE 	= 0
global constant GLUT_MENU_IN_USE 	= 1

--/* Visibility  state. */
global constant GLUT_NOT_VISIBLE 	= 0
global constant GLUT_VISIBLE 		= 1

--/* Window status  state. */
global constant GLUT_HIDDEN 		= 0
global constant GLUT_FULLY_RETAINED 	= 1
global constant GLUT_PARTIALLY_RETAINED = 2
global constant GLUT_FULLY_COVERED 	= 3

--/* Color index component selection values. */
global constant GLUT_RED 	= 0
global constant GLUT_GREEN 	= 1
global constant GLUT_BLUE 	= 2

--/* Layers for use. */
global constant GLUT_NORMAL 	= 0
global constant GLUT_OVERLAY 	= 1


--#if defined(WIN32)
--/* Stroke font constants (use these in GLUT program). */
global constant GLUT_STROKE_ROMAN		= 0
global constant GLUT_STROKE_MONO_ROMAN		= 1

--/* Bitmap font constants (use these in GLUT program). */
global constant GLUT_BITMAP_9_BY_15		= 2
global constant GLUT_BITMAP_8_BY_13		= 3
global constant GLUT_BITMAP_TIMES_ROMAN_10	= 4
global constant GLUT_BITMAP_TIMES_ROMAN_24	= 5
--#if (GLUT_API_VERSION >= 3)
global constant GLUT_BITMAP_HELVETICA_10	= 6
global constant GLUT_BITMAP_HELVETICA_12	= 7
global constant GLUT_BITMAP_HELVETICA_18	= 8
--#endif
--#else

--**********    I guess the below definitions are for X-Win.    **********
--********** I'm not sure about how to port them, so I didn't.. **********

----/* Stroke font opaque addresses (use constants instead in source code). */
--extern void *glutStrokeRoman;
--extern void *glutStrokeMonoRoman;

----/* Stroke font constants (use these in GLUT program). */
--global constant GLUT_STROKE_ROMAN		(&glutStrokeRoman)
--global constant GLUT_STROKE_MONO_ROMAN		(&glutStrokeMonoRoman)

----/* Bitmap font opaque addresses (use constants instead in source code). */
--extern void *glutBitmap9By15;
--extern void *glutBitmap8By13;
--extern void *glutBitmapTimesRoman10;
--extern void *glutBitmapTimesRoman24;
--extern void *glutBitmapHelvetica10;
--extern void *glutBitmapHelvetica12;
--extern void *glutBitmapHelvetica18;

----/* Bitmap font constants (use these in GLUT program). */
--global constant GLUT_BITMAP_9_BY_15		(&glutBitmap9By15)
--global constant GLUT_BITMAP_8_BY_13		(&glutBitmap8By13)
--global constant GLUT_BITMAP_TIMES_ROMAN_10	(&glutBitmapTimesRoman10)
--global constant GLUT_BITMAP_TIMES_ROMAN_24	(&glutBitmapTimesRoman24)
----#if (GLUT_API_VERSION >= 3)
--global constant GLUT_BITMAP_HELVETICA_10	(&glutBitmapHelvetica10)
--global constant GLUT_BITMAP_HELVETICA_12	(&glutBitmapHelvetica12)
--global constant GLUT_BITMAP_HELVETICA_18	(&glutBitmapHelvetica18)
--#endif
--#endif



--/* glutGet parameters. */
global constant GLUT_WINDOW_X			= 100
global constant GLUT_WINDOW_Y			= 101
global constant GLUT_WINDOW_WIDTH		= 102
global constant GLUT_WINDOW_HEIGHT		= 103
global constant GLUT_WINDOW_BUFFER_SIZE		= 104
global constant GLUT_WINDOW_STENCIL_SIZE	= 105
global constant GLUT_WINDOW_DEPTH_SIZE		= 106
global constant GLUT_WINDOW_RED_SIZE		= 107
global constant GLUT_WINDOW_GREEN_SIZE		= 108
global constant GLUT_WINDOW_BLUE_SIZE		= 109
global constant GLUT_WINDOW_ALPHA_SIZE		= 110
global constant GLUT_WINDOW_ACCUM_RED_SIZE	= 111
global constant GLUT_WINDOW_ACCUM_GREEN_SIZE	= 112
global constant GLUT_WINDOW_ACCUM_BLUE_SIZE	= 113
global constant GLUT_WINDOW_ACCUM_ALPHA_SIZE	= 114
global constant GLUT_WINDOW_DOUBLEBUFFER	= 115
global constant GLUT_WINDOW_RGBA		= 116
global constant GLUT_WINDOW_PARENT		= 117
global constant GLUT_WINDOW_NUM_CHILDREN	= 118
global constant GLUT_WINDOW_COLORMAP_SIZE	= 119
--#if (GLUT_API_VERSION >= 2)
global constant GLUT_WINDOW_NUM_SAMPLES		= 120
global constant GLUT_WINDOW_STEREO		= 121
--#endif
--#if (GLUT_API_VERSION >= 3)
global constant GLUT_WINDOW_CURSOR		= 122
--#endif
global constant GLUT_SCREEN_WIDTH		= 200
global constant GLUT_SCREEN_HEIGHT		= 201
global constant GLUT_SCREEN_WIDTH_MM		= 202
global constant GLUT_SCREEN_HEIGHT_MM		= 203
global constant GLUT_MENU_NUM_ITEMS		= 300
global constant GLUT_DISPLAY_MODE_POSSIBLE	= 400
global constant GLUT_INIT_WINDOW_X		= 500
global constant GLUT_INIT_WINDOW_Y		= 501
global constant GLUT_INIT_WINDOW_WIDTH		= 502
global constant GLUT_INIT_WINDOW_HEIGHT		= 503
global constant GLUT_INIT_DISPLAY_MODE		= 504
--#if (GLUT_API_VERSION >= 2)
global constant GLUT_ELAPSED_TIME		= 700
--#endif

--#if (GLUT_API_VERSION >= 2)
--/* glutDeviceGet parameters. */
global constant GLUT_HAS_KEYBOARD		= 600
global constant GLUT_HAS_MOUSE			= 601
global constant GLUT_HAS_SPACEBALL		= 602
global constant GLUT_HAS_DIAL_AND_BUTTON_BOX	= 603
global constant GLUT_HAS_TABLET			= 604
global constant GLUT_NUM_MOUSE_BUTTONS		= 605
global constant GLUT_NUM_SPACEBALL_BUTTONS	= 606
global constant GLUT_NUM_BUTTON_BOX_BUTTONS	= 607
global constant GLUT_NUM_DIALS			= 608
global constant GLUT_NUM_TABLET_BUTTONS		= 609
--#endif

--#if (GLUT_API_VERSION >= 3)
--/* glutLayerGet parameters. */
global constant GLUT_OVERLAY_POSSIBLE           = 800
global constant GLUT_LAYER_IN_USE		= 801
global constant GLUT_HAS_OVERLAY		= 802
global constant GLUT_TRANSPARENT_INDEX		= 803
global constant GLUT_NORMAL_DAMAGED		= 804
global constant GLUT_OVERLAY_DAMAGED		= 805

--#if (GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
--/* glutVideoResizeGet parameters. */
global constant GLUT_VIDEO_RESIZE_POSSIBLE	= 900
global constant GLUT_VIDEO_RESIZE_IN_USE	= 901
global constant GLUT_VIDEO_RESIZE_X_DELTA	= 902
global constant GLUT_VIDEO_RESIZE_Y_DELTA	= 903
global constant GLUT_VIDEO_RESIZE_WIDTH_DELTA	= 904
global constant GLUT_VIDEO_RESIZE_HEIGHT_DELTA	= 905
global constant GLUT_VIDEO_RESIZE_X		= 906
global constant GLUT_VIDEO_RESIZE_Y		= 907
global constant GLUT_VIDEO_RESIZE_WIDTH		= 908
global constant GLUT_VIDEO_RESIZE_HEIGHT	= 909
--#endif


--/* glutGetModifiers return mask. */
global constant GLUT_ACTIVE_SHIFT               = 1
global constant GLUT_ACTIVE_CTRL                = 2
global constant GLUT_ACTIVE_ALT                 = 4

--/* glutSetCursor parameters. */
--/* Basic arrows. */
global constant GLUT_CURSOR_RIGHT_ARROW		= 0
global constant GLUT_CURSOR_LEFT_ARROW		= 1
--/* Symbolic cursor shapes. */
global constant GLUT_CURSOR_INFO		= 2
global constant GLUT_CURSOR_DESTROY		= 3
global constant GLUT_CURSOR_HELP		= 4
global constant GLUT_CURSOR_CYCLE		= 5
global constant GLUT_CURSOR_SPRAY		= 6
global constant GLUT_CURSOR_WAIT		= 7
global constant GLUT_CURSOR_TEXT		= 8
global constant GLUT_CURSOR_CROSSHAIR		= 9
--/* Directional cursors. */
global constant GLUT_CURSOR_UP_DOWN		= 10
global constant GLUT_CURSOR_LEFT_RIGHT		= 11
--/* Sizing cursors. */
global constant GLUT_CURSOR_TOP_SIDE		= 12
global constant GLUT_CURSOR_BOTTOM_SIDE		= 13
global constant GLUT_CURSOR_LEFT_SIDE		= 14
global constant GLUT_CURSOR_RIGHT_SIDE		= 15
global constant GLUT_CURSOR_TOP_LEFT_CORNER	= 16
global constant GLUT_CURSOR_TOP_RIGHT_CORNER	= 17
global constant GLUT_CURSOR_BOTTOM_RIGHT_CORNER	= 18
global constant GLUT_CURSOR_BOTTOM_LEFT_CORNER	= 19
--/* Inherit from parent window. */
global constant GLUT_CURSOR_INHERIT		= 100
--/* Blank cursor. */
global constant GLUT_CURSOR_NONE		= 101
--/* Fullscreen crosshair (if available). */
global constant GLUT_CURSOR_FULL_CROSSHAIR	= 102
--#endif

-- Joystick button masks. 
global constant GLUT_JOYSTICK_BUTTON_A		=1
global constant GLUT_JOYSTICK_BUTTON_B		=2
global constant GLUT_JOYSTICK_BUTTON_C		=4
global constant GLUT_JOYSTICK_BUTTON_D		=8


-- GLUT game mode sub-API. 
-- glutGameModeGet. 
global constant GLUT_GAME_MODE_ACTIVE           =0
global constant GLUT_GAME_MODE_POSSIBLE         =1
global constant GLUT_GAME_MODE_WIDTH            =2
global constant GLUT_GAME_MODE_HEIGHT           =3
global constant GLUT_GAME_MODE_PIXEL_DEPTH      =4
global constant GLUT_GAME_MODE_REFRESH_RATE     =5
global constant GLUT_GAME_MODE_DISPLAY_CHANGED  =6




atom glut32

if platform()=LINUX then
	glut32 = open_dll(GL_LIBPATH & "libglut.so.3")
else
	glut32 = open_dll("glut32.dll")
end if

if glut32 = NULL then
 	if platform()=LINUX then
 		puts(1,"Error! Can\'t find " & GL_LIBPATH & "libglut.so.3")
  	else
  		puts(1,"Error! Can\'t find glut32.dll")
  	end if
  	abort(1)
end if

global integer  glutInit,glutInitDisplayMode,glutInitDisplayString,
                glutInitWindowPosition,glutInitWindowSize,glutMainLoop,
                glutCreateWindow,glutCreateSubWindow,glutDestroyWindow,
                glutPostRedisplay,glutPostWindowRedisplay,
                glutSwapBuffers,glutGetWindow,glutSetWindow,
                glutSetWindowTitle,glutSetIconTitle,glutPositionWindow,
                glutReshapeWindow,glutPopWindow,glutPushWindow,
                glutIconifyWindow,glutShowWindow,glutHideWindow,
                glutFullScreen,glutSetCursor,glutWarpPointer,
                glutEstablishOverlay,glutRemoveOverlay,glutUseLayer,
                glutPostOverlayRedisplay,glutPostWindowOverlayRedisplay,
                glutShowOverlay,glutHideOverlay,
                glutCreateMenu,glutDestroyMenu,glutGetMenu,glutSetMenu,
                glutAddMenuEntry,glutAddSubMenu,glutChangeToMenuEntry,
                glutChangeToSubMenu,glutRemoveMenuItem,glutAttachMenu,
                glutDetachMenu,glutDisplayFunc,glutReshapeFunc,
                glutKeyboardFunc,glutMouseFunc,glutMotionFunc,
                glutPassiveMotionFunc,glutEntryFunc,glutVisibilityFunc,
                glutIdleFunc,glutTimerFunc,glutMenuStateFunc,
                glutSpecialFunc,glutSpaceballMotionFunc,
                glutSpaceballRotateFunc,glutSpaceballButtonFunc,
                glutButtonBoxFunc,glutDialsFunc,glutTabletMotionFunc,
                glutTabletButtonFunc,glutMenuStatusFunc,glutOverlayDisplayFunc,
                glutWindowStatusFunc, 
		glutIgnoreKeyRepeat,glutSetKeyRepeat,
		glutForceJoystickFunc,glutJoystickFunc,
		glutGameModeString,glutEnterGameMode,
		glutLeaveGameMode,glutGameModeGet,
                
                glutWireSphere,glutSolidSphere,glutWireCone,glutSolidCone,
                glutWireCube,glutSolidCube,glutWireTorus,glutSolidTorus,
                glutWireDodecahedron,glutSolidDodecahedron,glutWireTeapot,
                glutSolidTeapot,glutWireOctahedron,glutSolidOctahedron,
                glutWireTetrahedron,glutSolidTetrahedron,glutWireIcosahedron,
                glutSolidIcosahedron





glutInit 		= validate_proc(glut32,"glutInit",{ C_POINTER,C_POINTER })
glutInitDisplayMode 	= validate_proc(glut32,"glutInitDisplayMode",{ C_UINT })
--#if (GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
glutInitDisplayString 	= validate_proc(glut32,"glutInitDisplayString",{ C_POINTER })
--#endif
glutInitWindowPosition 	= validate_proc(glut32,"glutInitWindowPosition",{ C_INT,C_INT })
glutInitWindowSize 	= validate_proc(glut32,"glutInitWindowSize",{ C_INT,C_INT })
glutMainLoop 		= validate_proc(glut32,"glutMainLoop",{ })
glutCreateWindow	= validate_func(glut32,"glutCreateWindow",{ C_POINTER },C_INT)
glutCreateSubWindow	= validate_func(glut32,"glutCreateSubWindow",repeat(C_INT,5),C_INT)
glutDestroyWindow 	= validate_proc(glut32,"glutDestroyWindow",{ C_INT })
glutPostRedisplay	= validate_proc(glut32,"glutPostRedisplay",{ })
--#if (GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 11)
glutPostWindowRedisplay	= validate_proc(glut32,"glutPostWindowRedisplay",{ C_INT })
--#endif
glutSwapBuffers		= validate_proc(glut32,"glutSwapBuffers",{ })
glutGetWindow		= validate_func(glut32,"glutGetWindow",{ },C_INT)
glutSetWindow		= validate_proc(glut32,"glutSetWindow",{ C_INT })
glutSetWindowTitle	= validate_proc(glut32,"glutSetWindowTitle",{ C_POINTER })
glutSetIconTitle	= validate_proc(glut32,"glutSetIconTitle",{ C_POINTER })
glutPositionWindow	= validate_proc(glut32,"glutPositionWindow",{ C_INT,C_INT })
glutReshapeWindow	= validate_proc(glut32,"glutReshapeWindow",{ C_INT,C_INT })
glutPopWindow		= validate_proc(glut32,"glutPopWindow",{ })
glutPushWindow		= validate_proc(glut32,"glutPushWindow",{ })
glutIconifyWindow	= validate_proc(glut32,"glutIconifyWindow",{ })
glutShowWindow		= validate_proc(glut32,"glutShowWindow",{ })
glutHideWindow		= validate_proc(glut32,"glutHideWindow",{ })
--#if (GLUT_API_VERSION >= 3)
glutFullScreen		= validate_proc(glut32,"glutFullScreen",{ })
glutSetCursor		= validate_proc(glut32,"glutSetCursor",{ C_INT })
--#if (GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
glutWarpPointer		= validate_proc(glut32,"glutWarpPointer",{ C_INT,C_INT })
--#endif
glutEstablishOverlay	= validate_proc(glut32,"glutEstablishOverlay",{ })
glutRemoveOverlay	= validate_proc(glut32,"glutRemoveOverlay",{ })
glutUseLayer		= validate_proc(glut32,"glutUseLayer",{ C_INT })
glutPostOverlayRedisplay= validate_proc(glut32,"glutPostOverlayRedisplay",{ })
--#if (GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 11)
glutPostWindowOverlayRedisplay= validate_proc(glut32,"glutPostWindowOverlayRedisplay",{ C_INT })
--#endif
glutShowOverlay		= validate_proc(glut32,"glutShowOverlay",{ })
glutHideOverlay		= validate_proc(glut32,"glutHideOverlay",{ })
--#endif
glutCreateMenu		= validate_func(glut32,"glutCreateMenu",{ C_POINTER },C_INT)
glutDestroyMenu		= validate_proc(glut32,"glutDestroyMenu",{ C_INT })
glutGetMenu		= validate_func(glut32,"glutGetMenu",{ },C_INT)
glutSetMenu		= validate_proc(glut32,"glutSetMenu",{ C_INT })
glutAddMenuEntry	= validate_proc(glut32,"glutAddMenuEntry",{ C_POINTER,C_INT })	
glutAddSubMenu		= validate_proc(glut32,"glutAddSubMenu",{ C_POINTER,C_INT })	
glutChangeToMenuEntry	= validate_proc(glut32,"glutChangeToMenuEntry",{ C_INT,C_POINTER,C_INT })
glutChangeToSubMenu	= validate_proc(glut32,"glutChangeToSubMenu",{ C_INT,C_POINTER,C_INT })
glutRemoveMenuItem	= validate_proc(glut32,"glutRemoveMenuItem",{ C_INT })
glutAttachMenu		= validate_proc(glut32,"glutAttachMenu",{ C_INT })
glutDetachMenu		= validate_proc(glut32,"glutDetachMenu",{ C_INT })
glutDisplayFunc		= validate_proc(glut32,"glutDisplayFunc",{ C_POINTER })
glutReshapeFunc		= validate_proc(glut32,"glutReshapeFunc",{ C_POINTER })
glutKeyboardFunc	= validate_proc(glut32,"glutKeyboardFunc",{ C_POINTER })
glutSpecialFunc		= validate_proc(glut32,"glutSpecialFunc",{ C_POINTER })
glutMouseFunc		= validate_proc(glut32,"glutMouseFunc",{ C_POINTER })
glutMotionFunc		= validate_proc(glut32,"glutMotionFunc",{ C_POINTER })
glutPassiveMotionFunc	= validate_proc(glut32,"glutPassiveMotionFunc",{ C_POINTER })
glutEntryFunc		= validate_proc(glut32,"glutEntryFunc",{ C_POINTER })
glutVisibilityFunc	= validate_proc(glut32,"glutVisibilityFunc",{ C_POINTER })
glutIdleFunc		= validate_proc(glut32,"glutIdleFunc",{ C_POINTER })
glutTimerFunc		= validate_proc(glut32,"glutTimerFunc",{ C_UINT,C_POINTER,C_INT })
glutMenuStateFunc	= validate_proc(glut32,"glutMenuStateFunc",{ C_POINTER })
--#if (GLUT_API_VERSION >= 2)
glutSpecialFunc		= validate_proc(glut32,"glutSpecialFunc",{ C_POINTER })
glutSpaceballMotionFunc	= validate_proc(glut32,"glutSpaceballMotionFunc",{ C_POINTER })
glutSpaceballRotateFunc	= validate_proc(glut32,"glutSpaceballRotateFunc",{ C_POINTER })
glutSpaceballButtonFunc	= validate_proc(glut32,"glutSpaceballButtonFunc",{ C_POINTER })
glutButtonBoxFunc	= validate_proc(glut32,"glutButtonBoxFunc",{ C_POINTER })
glutDialsFunc		= validate_proc(glut32,"glutDialsFunc",{ C_POINTER })
glutTabletMotionFunc	= validate_proc(glut32,"glutTabletMotionFunc",{ C_POINTER })
glutTabletButtonFunc	= validate_proc(glut32,"glutTabletButtonFunc",{ C_POINTER })
--#if (GLUT_API_VERSION >= 3)
glutMenuStatusFunc	= validate_proc(glut32,"glutMenuStatusFunc",{ C_POINTER })
glutOverlayDisplayFunc	= validate_proc(glut32,"glutOverlayDisplayFunc",{ C_POINTER })
--#if (GLUT_API_VERSION >= 4 || GLUT_XLIB_IMPLEMENTATION >= 9)
glutWindowStatusFunc	= validate_proc(glut32,"glutWindowStatusFunc",{ C_POINTER })
glutIgnoreKeyRepeat	= validate_proc(glut32,"glutIgnoreKeyRepeat",{C_INT})
glutSetKeyRepeat	= validate_proc(glut32,"glutSetKeyRepeat",{C_INT})
glutForceJoystickFunc	= validate_proc(glut32,"glutForceJoystickFunc",{})
glutJoystickFunc	= validate_proc(glut32,"glutJoystickFunc",{C_POINTER,C_INT})

glutGameModeString	= validate_proc(glut32,"glutGameModeString",{C_POINTER})
glutEnterGameMode	= validate_func(glut32,"glutEnterGameMode",{},C_INT)
glutLeaveGameMode	= validate_proc(glut32,"glutLeaveGameMode",{})
glutGameModeGet		= validate_func(glut32,"glutGameModeGet",{C_INT},C_INT)
--#endif
--#endif
--#endif

-- Various predefined primitives
glutWireSphere		= validate_proc(glut32,"glutWireSphere",{ C_DOUBLE,C_INT,C_INT })
glutSolidSphere		= validate_proc(glut32,"glutSolidSphere",{ C_DOUBLE,C_INT,C_INT })
glutWireCone		= validate_proc(glut32,"glutWireCone",{ C_DOUBLE,C_DOUBLE,C_INT,C_INT })
glutSolidCone		= validate_proc(glut32,"glutSolidCone",{ C_DOUBLE,C_DOUBLE,C_INT,C_INT })
glutWireCube		= validate_proc(glut32,"glutWireCube",{ C_DOUBLE })
glutSolidCube		= validate_proc(glut32,"glutSolidCube",{ C_DOUBLE })
glutWireTorus		= validate_proc(glut32,"glutWireTorus",{ C_DOUBLE,C_DOUBLE,C_INT,C_INT })
glutSolidTorus		= validate_proc(glut32,"glutSolidTorus",{ C_DOUBLE,C_DOUBLE,C_INT,C_INT })
glutWireDodecahedron	= validate_proc(glut32,"glutWireDodecahedron",{ })
glutSolidDodecahedron	= validate_proc(glut32,"glutSolidDodecahedron",{ })
glutWireTeapot		= validate_proc(glut32,"glutWireTeapot",{ C_DOUBLE })
glutSolidTeapot		= validate_proc(glut32,"glutSolidTeapot",{ C_DOUBLE })
glutWireOctahedron	= validate_proc(glut32,"glutWireOctahedron",{ })
glutSolidOctahedron	= validate_proc(glut32,"glutSolidOctahedron",{ })
glutWireTetrahedron	= validate_proc(glut32,"glutWireTetrahedron",{ })
glutSolidTetrahedron	= validate_proc(glut32,"glutSolidTetrahedron",{ })
glutWireIcosahedron	= validate_proc(glut32,"glutWireIcosahedron",{ })
glutSolidIcosahedron	= validate_proc(glut32,"glutSolidIcosahedron",{ })


constant glue_mem_buffer = allocate(128)


global procedure glut_addMenuEntry(sequence caption,integer id)
	poke(glue_mem_buffer,caption & 0)
	c_proc(glutAddMenuEntry,{glue_mem_buffer,id})
end procedure

global procedure glut_addSubMenu(sequence caption,atom menu)
	poke(glue_mem_buffer,caption & 0)
	c_proc(glutAddSubMenu,{glue_mem_buffer,menu})
end procedure

global procedure glut_attachMenu(integer toWhat)
	c_proc(glutAttachMenu,{toWhat})
end procedure

global function glut_createMenu(atom cb)
	return c_func(glutCreateMenu,{cb})
end function

global function glut_createWindow(sequence caption)
	poke(glue_mem_buffer,caption & 0)
	return c_func(glutCreateWindow,{glue_mem_buffer})
end function

global procedure glut_fullScreen()
	c_proc(glutFullScreen,{})
end procedure

global procedure glut_gameModeString(sequence s)
	poke(glue_mem_buffer,s&0)
	c_proc(glutGameModeString,{glue_mem_buffer})
end procedure

global procedure glut_init(atom argc,atom argv)
	c_proc(glutInit,{argc,argv})
end procedure

global procedure glut_initDisplayMode(integer mode)
	c_proc(glutInitDisplayMode,{mode})
end procedure

global procedure glut_initWindowPosition(integer x,integer y)
	c_proc(glutInitWindowPosition,{x,y})
end procedure

global procedure glut_initWindowSize(integer w,integer h)
	c_proc(glutInitWindowSize,{w,h})
end procedure

global procedure glut_displayFunc(atom cb)
	c_proc(glutDisplayFunc,{cb})
end procedure

global procedure glut_idleFunc(atom cb)
	c_proc(glutIdleFunc,{cb})
end procedure

global procedure glut_keyboardFunc(atom cb)
	c_proc(glutKeyboardFunc,{cb})
end procedure

global procedure glut_specialFunc(atom cb)
	c_proc(glutSpecialFunc,{cb})
end procedure

global procedure glut_reshapeFunc(atom cb)
	c_proc(glutReshapeFunc,{cb})
end procedure

global procedure glut_timerFunc(integer timeout,atom cb,integer param)
	c_proc(glutTimerFunc,{timeout,cb,param})
end procedure

global procedure glut_visibilityFunc(atom cb)
	c_proc(glutVisibilityFunc,{cb})
end procedure

global procedure glut_mainLoop()
	c_proc(glutMainLoop,{})
end procedure

global procedure glut_postRedisplay()
	c_proc(glutPostRedisplay,{})
end procedure

global procedure glut_solidIcosahedron()
	c_proc(glutSolidIcosahedron,{})
end procedure

global procedure glut_solidTetrahedron()
	c_proc(glutSolidTetrahedron,{})
end procedure

global procedure glut_solidTorus(atom a,atom b,integer c,integer d)
	c_proc(glutSolidTorus,{a,b,c,d})
end procedure

global procedure glut_wireTorus(atom a,atom b,integer c,integer d)
	c_proc(glutWireTorus,{a,b,c,d})
end procedure

global procedure glut_swapBuffers()
	c_proc(glutSwapBuffers,{})
end procedure
